<?php

namespace ThemeHouse\LastPostAvatar\XF\Repository;

class Node extends XFCP_Node
{
    public function getNodeListExtras(\XF\Tree $nodeTree)
    {
        $nodeListExtras = parent::getNodeListExtras($nodeTree);

        $nodeListExtras = $this->getLastPostAvatars($nodeListExtras);

        return $nodeListExtras;
    }

    protected function getLastPostAvatars($nodeListExtras)
    {
        $userIds = [];
        foreach ($nodeListExtras as $nodeId=>$extras) {
            if (!empty($extras['last_post_user_id']) && !in_array($extras['last_post_user_id'], $userIds)) {
                $userIds[] = $extras['last_post_user_id'];
            }
        }

        $users = $this->finder('XF:User')->where('user_id', '=', $userIds)->fetch();

        foreach ($nodeListExtras as &$extras) {
            if (!empty($users[$extras['last_post_user_id']])) {
                $extras['lastPostUser'] = $users[$extras['last_post_user_id']];
            }
        }

        return $nodeListExtras;
    }
}